<?php
/**
 * @copyright 2012,2013 Binovo it Human Project, S.L.
 * @license http://www.opensource.org/licenses/bsd-license.php New-BSD
 */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration,
    Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your need!
 */
class Version20121116152856 extends AbstractMigration
{
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        $this->addSql("CREATE TABLE Client (id INT AUTO_INCREMENT NOT NULL, description LONGTEXT DEFAULT NULL, isActive TINYINT(1) NOT NULL, name VARCHAR(255) NOT NULL, postScript LONGTEXT DEFAULT NULL, preScript LONGTEXT DEFAULT NULL, url VARCHAR(255) NOT NULL, UNIQUE INDEX UNIQ_C0E801635E237E06 (name), PRIMARY KEY(id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE LogRecord (id INT AUTO_INCREMENT NOT NULL, channel VARCHAR(255) NOT NULL, dateTime DATETIME NOT NULL, level INT NOT NULL, levelName VARCHAR(255) NOT NULL, link VARCHAR(255) DEFAULT NULL, message LONGTEXT NOT NULL, source VARCHAR(255) DEFAULT NULL, userId INT DEFAULT NULL, userName VARCHAR(255) DEFAULT NULL, PRIMARY KEY(id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE Policy (id INT AUTO_INCREMENT NOT NULL, description LONGTEXT DEFAULT NULL, name VARCHAR(255) NOT NULL, hourlyHours VARCHAR(255) DEFAULT NULL, hourlyDaysOfMonth VARCHAR(255) DEFAULT NULL, hourlyDaysOfWeek VARCHAR(255) DEFAULT NULL, hourlyMonths VARCHAR(255) DEFAULT NULL, hourlyCount INT NOT NULL, dailyHours VARCHAR(255) DEFAULT NULL, dailyDaysOfMonth VARCHAR(255) DEFAULT NULL, dailyDaysOfWeek VARCHAR(255) DEFAULT NULL, dailyMonths VARCHAR(255) DEFAULT NULL, dailyCount INT NOT NULL, weeklyHours VARCHAR(255) DEFAULT NULL, weeklyDaysOfMonth VARCHAR(255) DEFAULT NULL, weeklyDaysOfWeek VARCHAR(255) DEFAULT NULL, weeklyMonths VARCHAR(255) DEFAULT NULL, weeklyCount INT NOT NULL, monthlyHours VARCHAR(255) DEFAULT NULL, monthlyDaysOfMonth VARCHAR(255) DEFAULT NULL, monthlyDaysOfWeek VARCHAR(255) DEFAULT NULL, monthlyMonths VARCHAR(255) DEFAULT NULL, monthlyCount INT NOT NULL, yearlyHours VARCHAR(255) DEFAULT NULL, yearlyDaysOfMonth VARCHAR(255) DEFAULT NULL, yearlyDaysOfWeek VARCHAR(255) DEFAULT NULL, yearlyMonths VARCHAR(255) DEFAULT NULL, yearlyCount INT NOT NULL, include LONGTEXT DEFAULT NULL, exclude LONGTEXT DEFAULT NULL, syncFirst TINYINT(1) NOT NULL, PRIMARY KEY(id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE User (id INT AUTO_INCREMENT NOT NULL, username VARCHAR(25) NOT NULL, salt VARCHAR(32) NOT NULL, password VARCHAR(100) NOT NULL, email VARCHAR(60) NOT NULL, isActive TINYINT(1) NOT NULL, roles VARCHAR(255) NOT NULL, UNIQUE INDEX UNIQ_2DA17977F85E0677 (username), UNIQUE INDEX UNIQ_2DA17977E7927C74 (email), PRIMARY KEY(id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE Job (id INT AUTO_INCREMENT NOT NULL, client_id INT DEFAULT NULL, owner_id INT DEFAULT NULL, policy_id INT DEFAULT NULL, description LONGTEXT DEFAULT NULL, isActive TINYINT(1) NOT NULL, name VARCHAR(255) NOT NULL, notificationsEmail VARCHAR(255) DEFAULT NULL, notificationsTo VARCHAR(255) NOT NULL, minNotificationLevel INT NOT NULL, postScript LONGTEXT DEFAULT NULL, preScript LONGTEXT DEFAULT NULL, url VARCHAR(255) NOT NULL, INDEX IDX_C395A61819EB6921 (client_id), INDEX IDX_C395A6187E3C61F9 (owner_id), INDEX IDX_C395A6182D29E3C6 (policy_id), PRIMARY KEY(id)) ENGINE = InnoDB");
        $this->addSql("ALTER TABLE Job ADD CONSTRAINT FK_C395A61819EB6921 FOREIGN KEY (client_id) REFERENCES Client (id)");
        $this->addSql("ALTER TABLE Job ADD CONSTRAINT FK_C395A6187E3C61F9 FOREIGN KEY (owner_id) REFERENCES User (id)");
        $this->addSql("ALTER TABLE Job ADD CONSTRAINT FK_C395A6182D29E3C6 FOREIGN KEY (policy_id) REFERENCES Policy (id)");
        $this->addSql("INSERT INTO `Policy` VALUES (1,'Example policy','Default policy','12:00|15:00|21:00',NULL,'1|2|3|4|5',NULL,0,'21:00',NULL,'1|2|3|4|5',NULL,5,'21:00',NULL,'1',NULL,4,'21:00','1',NULL,NULL,12,'21:00',NULL,NULL,NULL,0,NULL,NULL,1)");
    }

    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        $this->addSql("ALTER TABLE Job DROP FOREIGN KEY FK_C395A61819EB6921");
        $this->addSql("ALTER TABLE Job DROP FOREIGN KEY FK_C395A6182D29E3C6");
        $this->addSql("ALTER TABLE Job DROP FOREIGN KEY FK_C395A6187E3C61F9");
        $this->addSql("DROP TABLE Client");
        $this->addSql("DROP TABLE LogRecord");
        $this->addSql("DROP TABLE Policy");
        $this->addSql("DROP TABLE User");
        $this->addSql("DROP TABLE Job");
    }
}
