<?php
/**
 * @copyright 2012,2013 Binovo it Human Project, S.L.
 * @license http://www.opensource.org/licenses/bsd-license.php New-BSD
 */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration,
    Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your need!
 */
class Version20130222082246 extends AbstractMigration
{
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        $this->addSql("CREATE TABLE ClientScriptPost (client_id INT NOT NULL, script_id INT NOT NULL, INDEX IDX_49132A8919EB6921 (client_id), INDEX IDX_49132A89A1C01850 (script_id), PRIMARY KEY(client_id, script_id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE ClientScriptPre (client_id INT NOT NULL, script_id INT NOT NULL, INDEX IDX_7EBF6DF919EB6921 (client_id), INDEX IDX_7EBF6DF9A1C01850 (script_id), PRIMARY KEY(client_id, script_id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE JobScriptPost (job_id INT NOT NULL, script_id INT NOT NULL, INDEX IDX_C1C2251FBE04EA9 (job_id), INDEX IDX_C1C2251FA1C01850 (script_id), PRIMARY KEY(job_id, script_id)) ENGINE = InnoDB");
        $this->addSql("CREATE TABLE JobScriptPre (job_id INT NOT NULL, script_id INT NOT NULL, INDEX IDX_A7EA1D21BE04EA9 (job_id), INDEX IDX_A7EA1D21A1C01850 (script_id), PRIMARY KEY(job_id, script_id)) ENGINE = InnoDB");
        $this->addSql("ALTER TABLE ClientScriptPost ADD CONSTRAINT FK_49132A8919EB6921 FOREIGN KEY (client_id) REFERENCES Client (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE ClientScriptPost ADD CONSTRAINT FK_49132A89A1C01850 FOREIGN KEY (script_id) REFERENCES Script (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE ClientScriptPre ADD CONSTRAINT FK_7EBF6DF919EB6921 FOREIGN KEY (client_id) REFERENCES Client (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE ClientScriptPre ADD CONSTRAINT FK_7EBF6DF9A1C01850 FOREIGN KEY (script_id) REFERENCES Script (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE JobScriptPost ADD CONSTRAINT FK_C1C2251FBE04EA9 FOREIGN KEY (job_id) REFERENCES Job (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE JobScriptPost ADD CONSTRAINT FK_C1C2251FA1C01850 FOREIGN KEY (script_id) REFERENCES Script (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE JobScriptPre ADD CONSTRAINT FK_A7EA1D21BE04EA9 FOREIGN KEY (job_id) REFERENCES Job (id) ON DELETE CASCADE");
        $this->addSql("ALTER TABLE JobScriptPre ADD CONSTRAINT FK_A7EA1D21A1C01850 FOREIGN KEY (script_id) REFERENCES Script (id) ON DELETE CASCADE");
        $this->addSql("INSERT INTO ClientScriptPost (client_id, script_id) SELECT id, postScript_id FROM Client WHERE postScript_id IS NOT NULL");
        $this->addSql("INSERT INTO ClientScriptPre  (client_id, script_id) SELECT id, preScript_id  FROM Client WHERE preScript_id  IS NOT NULL");
        $this->addSql("INSERT INTO JobScriptPost    (job_id, script_id)    SELECT id, postScript_id FROM Job    WHERE postScript_id IS NOT NULL");
        $this->addSql("INSERT INTO JobScriptPre     (job_id, script_id)    SELECT id, preScript_id  FROM Job    WHERE preScript_id  IS NOT NULL");
        $this->addSql("ALTER TABLE Client DROP FOREIGN KEY FK_C0E80163B21C5632");
        $this->addSql("ALTER TABLE Client DROP FOREIGN KEY FK_C0E80163B27EDC0");
        $this->addSql("DROP INDEX IDX_C0E80163B21C5632 ON Client");
        $this->addSql("DROP INDEX IDX_C0E80163B27EDC0 ON Client");
        $this->addSql("ALTER TABLE Client DROP postScript_id, DROP preScript_id");
        $this->addSql("ALTER TABLE Job DROP FOREIGN KEY FK_C395A618B21C5632");
        $this->addSql("ALTER TABLE Job DROP FOREIGN KEY FK_C395A618B27EDC0");
        $this->addSql("DROP INDEX IDX_C395A618B21C5632 ON Job");
        $this->addSql("DROP INDEX IDX_C395A618B27EDC0 ON Job");
        $this->addSql("ALTER TABLE Job DROP postScript_id, DROP preScript_id");
    }

    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != "mysql");

        $this->addSql("DROP TABLE ClientScriptPost");
        $this->addSql("DROP TABLE ClientScriptPre");
        $this->addSql("DROP TABLE JobScriptPost");
        $this->addSql("DROP TABLE JobScriptPre");
        $this->addSql("ALTER TABLE Client ADD postScript_id INT DEFAULT NULL, ADD preScript_id INT DEFAULT NULL");
        $this->addSql("ALTER TABLE Client ADD CONSTRAINT FK_C0E80163B21C5632 FOREIGN KEY (postScript_id) REFERENCES Script (id)");
        $this->addSql("ALTER TABLE Client ADD CONSTRAINT FK_C0E80163B27EDC0 FOREIGN KEY (preScript_id) REFERENCES Script (id)");
        $this->addSql("CREATE INDEX IDX_C0E80163B21C5632 ON Client (postScript_id)");
        $this->addSql("CREATE INDEX IDX_C0E80163B27EDC0 ON Client (preScript_id)");
        $this->addSql("ALTER TABLE Job ADD postScript_id INT DEFAULT NULL, ADD preScript_id INT DEFAULT NULL");
        $this->addSql("ALTER TABLE Job ADD CONSTRAINT FK_C395A618B21C5632 FOREIGN KEY (postScript_id) REFERENCES Script (id)");
        $this->addSql("ALTER TABLE Job ADD CONSTRAINT FK_C395A618B27EDC0 FOREIGN KEY (preScript_id) REFERENCES Script (id)");
        $this->addSql("CREATE INDEX IDX_C395A618B21C5632 ON Job (postScript_id)");
        $this->addSql("CREATE INDEX IDX_C395A618B27EDC0 ON Job (preScript_id)");
    }
}
